=== AspectC++/tests/CompoundGetSetAdvice/Makefile ===
ACFLAGS ?= --builtin_operators --apiext_entity --data_joinpoints
include ../Makefile.generic
