=== AspectC++/tests/FunctionEntity/Makefile ===
ACFLAGS ?= --apiext_entity
include ../Makefile.generic
