=== debian/changelog ===
aspectc++ (1:1.2+svn20150823-1) unstable; urgency=medium

  * New upstream snapshot
  * Compiles with GCC-5, Closes: #777781
  * Bump standard version, no changes needed
  * This package is now maintained on git.debian.org

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 23 Aug 2015 22:04:29 -0400
