## aspectc++ 2.0+svn20160329

=== AspectC++/Makefile ===
--- 
+++ 
@@ -3,8 +3,8 @@
 # ******************************
 
 # AspectC++ supports alternative frontends: Puma or Clang
-# It can be configured the 'make FRONTEND=...'. Default is Puma.
-FRONTEND ?= Puma
+# It can be configured the 'make FRONTEND=...'. Default is Clang.
+export FRONTEND ?= Clang
 
 # PUMA root
 PUMA    ?= ../Puma
@@ -19,42 +19,45 @@
 # => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
 include $(PUMA)/vars.mk
 
+# check whether we compile for Windows: TARGET-Variable starts with 'win'
+ifneq ($(filter win%,$(TARGET)),)
+	WIN := yes
+	EXT := .exe
+endif
+
 # libxml2 settings
-ifeq ($(_TARGET),win32)
-	LIBXML2_INC := `mingw32-xml2-config --cflags` 
-	LIBXML2_LIB := `mingw32-xml2-config --libs`
-	EXT=.exe
-else
-	LIBXML2_INC := `xml2-config --cflags` 
-	LIBXML2_LIB := `xml2-config --libs` 
-endif
+LIBXML2_INC := `xml2-config --cflags` 
+LIBXML2_LIB := `xml2-config --libs` 
 
 # Check Clang version
-ifeq ($(FRONTEND),Clang)
-  ifeq ($(shell which $(LLVMCONF)),)
-    $(error FRONTEND is 'Clang', but LLVMCONF ($(LLVMCONF)) is not found)
-  endif
-  LLVM_VERSION := $(shell $(LLVMCONF) --version)
-  LLVM_SUPPORTED_VERSIONS := 3.4 3.6.2
-  LLVM_SYMBOLS := _ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
-                  _ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
-                  _ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
-                  _ZN5clang4Sema25ActOnEndOfTranslationUnitEv \
-                  _ZN5clang12Preprocessor3LexERNS_5TokenE
-  LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
-  ifneq ($(filter $(LLVM_SUPPORTED_VERSIONS), $(LLVM_VERSION)),)
-    $(info Clang version $(LLVM_VERSION): Fine)
-  else
-    $(warning Warning: UNSUPPORTED Clang version $(LLVM_VERSION) used)
-    LLVM_FOUND   := $(foreach SYM, $(LLVM_SYMBOLS), $(shell nm --defined-only $(LLVM_LIBDIR)/libclang*.a | grep -w -c $(SYM)))
-    ifneq ($(words $(LLVM_SYMBOLS)),$(words $(filter 1, $(LLVM_FOUND))))
-      $(error Incompatible Clang version '$(LLVM_VERSION)': Not all wrapped symbols defined!)
+ifneq ($(MAKECMDGOALS),clean)
+  ifeq ($(FRONTEND),Clang)
+    ifeq ($(shell which $(LLVMCONF)),)
+      $(error FRONTEND is 'Clang', but LLVMCONF ($(LLVMCONF)) is not found)
+    endif
+    LLVM_VERSION := $(shell $(LLVMCONF) --version)
+    LLVM_SUPPORTED_VERSIONS := 3.4 3.4svn 3.4.2 3.6.2 3.7.1
+    LLVM_SYMBOLS := _ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
+                    _ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
+                    _ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
+                    _ZN5clang4Sema25ActOnEndOfTranslationUnitEv \
+                    _ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE \
+                    _ZN5clang12Preprocessor3LexERNS_5TokenE
+    LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
+    ifneq ($(filter $(LLVM_SUPPORTED_VERSIONS), $(LLVM_VERSION)),)
+      $(info Clang version $(LLVM_VERSION): Fine)
+    else
+      $(warning Warning: UNSUPPORTED Clang version $(LLVM_VERSION) used)
+      LLVM_FOUND   := $(foreach SYM, $(LLVM_SYMBOLS), $(shell nm --defined-only $(LLVM_LIBDIR)/libclang*.a | grep -w -c $(SYM)))
+      ifneq ($(words $(LLVM_SYMBOLS)),$(words $(filter 1, $(LLVM_FOUND))))
+        $(error Incompatible Clang version '$(LLVM_VERSION)': Not all wrapped symbols defined!)
+      endif
     endif
   endif
 endif
 
 # linker settings
-ifneq ($(_TARGET),macosx)
+ifneq ($(_TARGET),macosx_x86_64)
 ifeq ($(SHARED),)
   LDFLAGS += -static
 endif
@@ -79,7 +82,7 @@
 
 LDFLAGS += $(LIBXML2_LIB)
 ifneq ($(FRONTEND),Puma)
-ifneq ($(_TARGET),macosx)
+ifneq ($(_TARGET),macosx_x86_64)
   LDFLAGS += -lclangRewriteFrontend -lclangRewriteCore -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
   LDFLAGS += $(patsubst %,-Xlinker --wrap=%,$(LLVM_SYMBOLS))
   LDFLAGS += `$(LLVMCONF) --ldflags`
@@ -89,15 +92,18 @@
   LDFLAGS += `$(LLVMCONF) --ldflags`
 endif
 ifneq ($(LLVM_VERSION),3.4)
+ifneq ($(LLVM_VERSION),3.4svn)
+ifneq ($(LLVM_VERSION),3.4.2)
   LDFLAGS := $(patsubst -lclangRewriteCore, -lclangRewrite, $(LDFLAGS))
   LDFLAGS += `$(LLVMCONF) --system-libs` # in 3.6 ldflags doesn't contain the system libs anymore
 endif
 endif
+endif
+endif
 
 # compiler settings
-ifeq ($(_TARGET),win32)
-        CPPFLAGS += -I $(PUMA)/src/win32/regex
-	RES := mingw32-windres
+ifeq ($(WIN),yes)
+	RES := windres
 	RCFILES := win-ac++.rc
 endif
 
@@ -105,10 +111,20 @@
 ifeq ($(FRONTEND),Puma)
   CPPFLAGS += -DFRONTEND_PUMA
 else
-  CPPFLAGS += `$(LLVMCONF) --cppflags`
+  FILTEROUT :=
+ifeq ($(RELEASE),debug)
+  # filter-out "-DNDEBUG" added by LLVMCONF, if LLVM is in built in release-mode
+  FILTEROUT := -DNDEBUG
+endif
+  LLVM_CPPFLAGS := $(shell $(LLVMCONF) --cppflags)
+  ifeq ($(WIN),yes)
+    # llvm-config on Windows generates path name with '\' that mingw g++ can't handle properly
+    LLVM_CPPFLAGS := $(subst \,/,$(LLVM_CPPFLAGS))
+  endif
+  CPPFLAGS += $(filter-out $(FILTEROUT),$(LLVM_CPPFLAGS))
   CPPFLAGS += -DFRONTEND_CLANG
   CXXFLAGS += -fno-rtti -Wno-strict-aliasing # hide annoying warning in Clang header 
-  CXXFLAGS += -std=c++11 # Clang uses C++11 features
+  CXXFLAGS += -std=gnu++11 # Clang uses C++11 features; "c++11" does not work -> WIN32 not defined on Windows!
 endif
 
 # profiling
@@ -228,14 +244,15 @@
 	@$(MAKE) -C ACModel
 
 $(PROG): $(OBJECTS) | libacmodel
-# For clang on macosx we create relinked objects with the patched symbols.
+# For clang on macosx_x86_64 we create relinked objects with the patched symbols.
 ifneq ($(FRONTEND),Puma)
-ifeq ($(_TARGET),macosx)
+ifeq ($(_TARGET),macosx_x86_64)
 	@echo "Creating patched clang libraries ..."
 	@$(LD) -r `$(LLVMCONF) --libdir`/libclangSema.a -o libclangSema.o -all_load \
 	  -alias __ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ ___real__ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ -unexported_symbol __ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
 	  -alias __ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj ___real__ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj -unexported_symbol __ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
 	  -alias __ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE ___real__ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE -unexported_symbol __ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
+          -alias __ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE ___real__ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE -unexported_symbol __ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE \
 	  -alias __ZN5clang4Sema25ActOnEndOfTranslationUnitEv ___real__ZN5clang4Sema25ActOnEndOfTranslationUnitEv -unexported_symbol __ZN5clang4Sema25ActOnEndOfTranslationUnitEv
 	@$(LD) -r `$(LLVMCONF) --libdir`/libclangLex.a -o libclangLex.o -all_load \
 	  -alias __ZN5clang12Preprocessor3LexERNS_5TokenE ___real__ZN5clang12Preprocessor3LexERNS_5TokenE -unexported_symbol __ZN5clang12Preprocessor3LexERNS_5TokenE
@@ -256,7 +273,7 @@
 
 # -Wold-style-cast to find classic C casts "a = (A*)b;"
 
-ifeq ($(_TARGET),win32)
+ifeq ($(WIN),yes)
 $(OBJECTDIR)/%.o : %.rc
 	@echo Compiling Windows resource file
 	@mkdir -p $(OBJECTDIR)
