=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -5,10 +5,11 @@
 ifeq ($(MAKELEVEL),0)
 $(error Sorry, this makefile is not intended to be \
 used directly. Please use the makefile in the toplevel \
-directory of the ApectC++ source tree instead)
+directory of the AspectC++ source tree instead)
 endif
 
 SHELL=/bin/bash
+DIFF=diff --strip-trailing-cr
 
 ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
           Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
@@ -26,21 +27,26 @@
 	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 Bug209 \
           MatchStatic Bug512 SliceJPAPI JPTL NamedPointcuts AspectPrivileges \
 	  RepoInvalid RepoVersion Bug321 Bug484 Bug524 DisjointIds AspectOf \
-	  Bug549 Bug552 Bug554 DefaultArgs
+	  MemberPointCut MatchScopeWithin \
+	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
+	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
+          VirtualPointcuts
 
 ifeq ($(FRONTEND),Clang)
 ACTESTS += DataFlowAnalysis
-ACTESTS += CallBuiltinOperator
+ACTESTS += CallBuiltinOperator MemberPointCut2
 ACTESTS += SimpleGetAdvice SimpleSetAdvice CompoundGetSetAdvice FunctionEntity \
-           SimpleRefAdvice \
-           Bug-Typenames DefaultArgs2
+           SimpleRefAdvice SimpleAliasAccessMember SimpleGetSetFuncPtr \
+           ArrayAccessAdvice MatchScope GetBaseDerived \
+           Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
+           Bug567 Bug568 Bug548 Bug589 Bug594
 endif
 
 # disabled: UnsizedArray
 # to be removed: NonInlineIntroInclude
 # (uses deprecated introduction syntax massively)
 
-ACMSGTESTS := RepoInvalid RepoVersion
+ACMSGTESTS := RepoInvalid RepoVersion Bug570
 
 ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))
 
@@ -69,13 +75,13 @@
 	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
-	cat $(1)/feature.err >> $(1)/feature.out; \
+	cp $(1)/feature.err $(1)/feature.out; \
 	rm $(1)/feature.err; \
 	exec 6>&1; \
 	exec 7>&2; \
 	exec > $(STDOUT_FILE); \
 	exec 2> $(STDERR_FILE); \
-	diff $(1)/feature.out $(1)/feature.ref; \
+	$(MAKE) -s EXT="$(EXT)" -C $(1) diff-only; \
 	RET=$$?; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
@@ -180,13 +186,13 @@
 	$(MAKE) -s EXT="$(EXT)" -C $< ; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
-	cat $</feature.err >> $</feature.out; \
+	cp $</feature.err $</feature.out; \
 	rm $</feature.err; \
 	exec 6>&1; \
 	exec 7>&2; \
 	exec > $(STDOUT_FILE); \
 	exec 2> $(STDERR_FILE); \
-	diff $</feature.out $</feature.ref; \
+	$(MAKE) -s EXT="$(EXT)" -C $< diff-only; \
 	RET=$$?; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
@@ -244,6 +250,7 @@
 	$(MAKE) -s EXT="$(EXT)" -C $< ref; 
 
 %.run:	%
+	@echo Making and running test '$<'
 	cd $< && $(MAKE) run
 
 %.clean: %
