=== debian/changelog ===
aspectc++ (1:2.0+svn20160329-1~bpo8.0) jessie-backports; urgency=medium

  * build against libclang 3.4

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 30 May 2016 20:13:57 -0400

aspectc++ (1:2.0+svn20160329-1) unstable; urgency=medium

  * Imported Upstream version 2.0+svn20160329

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 28 Mar 2016 23:26:18 -0400

aspectc++ (1:2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 04 Mar 2016 09:36:24 -0500

aspectc++ (1:2.0-1) experimental; urgency=medium

  * Imported Upstream version 2.0
  * Bump standard version, no changes needed

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 28 Feb 2016 10:27:33 -0500

aspectc++ (1:1.2+svn20151025-1) unstable; urgency=medium

  * New upstream version
  * Enable LLVM support, Closes: #754697

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 24 Aug 2015 20:42:29 -0400
