=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Reinhard Tartler <siretart@tauware.de>
-Build-Depends: debhelper (>= 7.0.0), libxml2-dev, docbook-to-man, zlib1g-dev
+Build-Depends: debhelper (>= 7.0.0), libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-3.4-dev, libclang-3.4-dev
 Build-Depends-Indep: doxygen, graphviz, gsfonts
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://www.aspectc.org
 Vcs-Git: git://anonscm.debian.org/collab-maint/aspectc++.git
