=== debian/rules ===
--- 
+++ 
@@ -40,7 +40,7 @@
 test-builds: build-arch-stamp
 	Ag++/bin/linux-release/ag++ --gen_config
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	$(MAKE) -C AspectC++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
+	$(MAKE) -C AspectC++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4 test
 	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
 	$(MAKE) -C Ag++/      SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
 endif
@@ -50,21 +50,15 @@
 build-arch: build-arch-stamp test-builds
 build-arch-stamp:
 	dh_testdir
-	# save a copy of Puma that will be woven later
-	cp -r Puma Puma.copy
-	$(MAKE) -C Puma/               -j$(NUMJOBS) compile
-	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all
+	$(MAKE) -C Puma/ MINI=1        -j$(NUMJOBS) all
+	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4
 	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
-	# ok, now we have both an ac++ binary and ag++ binary
-	# now let's weave Puma again in the copy
-	$(MAKE) -C Puma.copy clean
-	$(MAKE) -C Puma.copy all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
-	# let's clean and compile ac++ and ag++ again with new Puma
-	$(MAKE) -C AspectC++ clean
-	$(MAKE) -C Ag++      clean
-	$(MAKE) -C AspectC++ SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all
-	$(MAKE) -C Ag++      SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all
-
+	# ok, now we have both an ac++ binary and ag++ binary now let's
+	# weave Puma again in the copy
+	$(MAKE) -C Puma clean
+	$(MAKE) -C Puma all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
+	# FIXME: The testsuite seems to ignore failures
+	$(MAKE) -C AspectC++ examples test FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4 SHARED=1 AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" REGRESSIONTEST=1
 	# build manpages:
 	docbook-to-man debian/ac++.1.sgml > ac++.1
 	docbook-to-man debian/ag++.1.sgml > ag++.1
@@ -82,17 +76,18 @@
 	dh_testroot
 	dh_clean build-*stamp binary-*stamp puma.config
 	# cleaning up source directories:
-	$(MAKE) -s -C Puma libclean
-	$(MAKE) -s -C Puma tools-clean
-	$(MAKE) -s -C Puma docs-clean
-	$(MAKE) -s -C Puma examples-clean
-	$(MAKE) -s -C AspectC++ clean
-	$(MAKE) -s -C Ag++ clean
+	$(MAKE) -s -C Puma cleanall
+	# The clang frontend adds additional tests that need cleaning
+	# so far, no tests are excluded by using the Clang frontend
+	-$(MAKE) -s -C AspectC++ cleanall FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4
+	-$(MAKE) -s -C Ag++ clean
 	# remove leftovers from Upstream Makefiles
+	rm -rf Puma/include
 	rm -rf AspectC++/tests/RepoVersion/repo.use
 	rm -rf Ag++/DepFiles Ag++/ObjFiles Ag++/bin Ag++/tests/test_11.config
 	rm -rf AspectC++/DepFiles AspectC++/ObjFiles AspectC++/bin
 	rm -rf AspectC++/tests/*/feature.out
+	rm -rf AspectC++/tests/RepoVersion/feature.fil
 	# remove generated manpages:
 	rm -f ac++.1 ag++.1
 	rm -rf AspectC++/bin
